<script>
	import LoadSdk from './loadSDK.svelte';
	import { createEventDispatcher } from 'svelte';
	import { login } from '$lib/preferences';

	let L = {};
	let map = '';
	const dispatch = createEventDispatcher();

	export let options;

	let {
		zoom = 6,
		maxZoom = 19,
		minZoom = 1,
		mapID = 'map',
		attributionControl = true,
		center = [47, 2],
		markers,
		circles,
		clusters,
		geojson,
		recenter = false,
		scrollWheelZoom = true,
		tilelayers = [
			{
				url:
					'https://{s}.basemaps.cartocdn.com/rastertiles/voyager_labels_under/{z}/{x}/{y}{r}.png',
				attribution: `&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors &copy; <a href="https://carto.com/attributions">CARTO</a>`
			}
		],
		controls = {
			zoomControl: true,
			position: 'topleft',
			scale: false
		}
	} = options;

	let icon;
	let markersArray = [];
	let circleArray = [];
	let bounds;
	let defaultIcon = {
		iconUrl: 'assets/icons/cloudy.svg',
		iconSize: [48, 48],
		iconAnchor: [12, 41],
		popupAnchor: [1, -34],
		tooltipAnchor: [1, -34]
	};

	function initialise() {
		setTimeout(() => {
			L = window['L'];
			createMap();
			dispatch('ready');
		}, 1);
	}

	function makePopup(marker, options) {
		marker
			.bindPopup(options.text, {
				closeOnClick: false,
				autoClose: false,
				...options
			})
			.addTo(map);
		if (options.isOpen) {
			marker.openPopup();
		}
	}
	function makeTooltip(marker, options) {
		marker.bindTooltip(options.text, { ...options }).addTo(map);
		if (options.isOpen) {
			marker.openTooltip();
		}
	}
	let m = [];

	export const addMarker = (obj) => {
		obj.markers.map((e, i) => {
			if (e.icon) {
				icon = L.icon(e.icon);
			}
			m[i] = new L.marker([e.lat, e.lng], { icon }).addTo(map);
			if (e.popup) {
				makePopup(m[i], e.popup);
			}
			if (e.tooltip) {
				makeTooltip(m[i], e.tooltip);
			}
		});
	};
	let added = false;
	export const getMap = () => {
		return map;
	};
	export const getL = () => {
		return L;
	};
	export const updateMarkers = (obj) => {
		if (!added) {
			addMarker(obj);
			added = true;
		}
		obj.markers.map((i, k) => {
			m[k].setLatLng(i).update();
			m[k].addTo(map);
		});
	};
	export const setZoom = (x = 5) => {
		map.setZoom(x);
	};
	function createMap() {
		map = L.map(mapID, {
			attributionControl,
			zoomControl: controls.zoomControl,
			minZoom,
			maxZoom
		}).setView(center, zoom);
		m = L.marker([0, 0]);
		if (tilelayers) {
			tilelayers.map((e) => {
				L.tileLayer(e.url, {
					...e
				}).addTo(map);
			});
		}
		if (!scrollWheelZoom) {
			map.scrollWheelZoom.disable();
		}
		let controlElement = L.control;
		if (!controls.zoomControl) {
			controlElement().remove();
		}
		if (controls.scale) {
			controlElement.scale({ position: controls.position }).addTo(map);
		}
		if (controls.zoomControl && controls.position) {
			map.removeControl(map.zoomControl);
			controlElement
				.zoom({
					position: controls.position
				})
				.addTo(map);
		}
		if (markers) {
			markers.map((e) => {
				markersArray.push([e.lat, e.lng]);
				if (e.icon) {
					icon = L.icon(e.icon);
				} else {
					icon = L.icon(defaultIcon);
				}
				let marker = new L.marker([e.lat, e.lng], { icon });
				if (e.popup) {
					makePopup(marker, e.popup);
				}
				if (e.tooltip) {
					makeTooltip(marker, e.tooltip);
				}
				marker.addTo(map);
			});
		}
		if (circles) {
			circles.map((e) => {
				circleArray.push([e.lat, e.lng]);
				let circle = new L.circle([e.lat, e.lng], { ...e });
				if (e.popup) {
					makePopup(circle, e.popup);
				}
				if (e.tooltip) {
					makeTooltip(circle, e.tooltip);
				}
				circle.addTo(map);
			});
		}
		if (recenter) {
			if (markersArray.length == 1) {
				map.panTo(L.latLng(markersArray[0][0], markersArray[0][1]));
				map.setZoom(zoom);
			} else {
				bounds = new L.LatLngBounds(markersArray);
				map.fitBounds(bounds);
			}
		}

		if (clusters) {
			let cluster = L.markerClusterGroup({
				maxClusterRadius: 80,
				iconCreateFunction: function (cluster) {
					let marker = cluster.getAllChildMarkers()[0];
					if (marker.rr <= 5) {
						return L.divIcon({
							html: '<div class="cluster-icon"><img src="assets/icons/sun.svg" /></div>',
							className: 'cluster-icon-reset'
						});
					}
					if (marker.rr <= 15) {
						return L.divIcon({
							html: '<div class="cluster-icon"><img src="assets/icons/cloudy.svg" /></div>',
							className: 'cluster-icon-reset'
						});
					}

					return L.divIcon({
						html: '<div class="cluster-icon"><img src="assets/icons/rain.svg" /></div>',
						className: 'cluster-icon-reset'
					});
				}
			});
			clusters.forEach((node) => {
				if (node.getIcon()) {
					icon = L.icon(node.getIcon());
				} else {
					icon = L.icon(defaultIcon);
				}
				let marker = L.marker([node.lat, node.lng], { icon });
				marker.bindPopup(node.title);
				marker.tn = node.tn;
				marker.tx = node.tx;
				marker.rr = node.rr;
				cluster.addLayer(marker);
			});
			map.addLayer(cluster);
		}
		if (geojson) {
			L.geoJson(geojson.general).addTo(map);
			L.geoJson(geojson.selected, {
				style: {
					color: '#DB2777',
					opacity: 1,
					fillOpacity: 0.6
				}
			}).addTo(map);
		}
		return map;
	}
	function resizeMap() {
		if (map) {
			map.invalidateSize();
		}
	}
</script>

<svelte:window on:resize={resizeMap} />

<div class="map" id={mapID} bind:this={mapID} />

<LoadSdk on:ready={initialise} />

<style>
	.map {
		height: inherit;
		width: inherit;
	}

	:global(.cluster-icon-reset) {
		width: 0;
	}

	:global(.cluster-icon) {
		width: 48px;
		height: 48px;
	}
</style>
